//#include <SoftwareSerial.h>
//#include "DHT.h"
//#include "GSM.h"
//SoftwareSerial Serial1(7, 8);
//#define DHTPIN 7    // pin на котором висит датчик температуры
//DHT dht;  // DHT 22 тип датчика
//Отсылается смс в формате: влажность;температура;устройство1;устройство2;устройство3;устройство4;Контроль периметра;Состояние периметра;Контроль автотемпературы;Установленная температура;STEWARD;
int greenLed = 13; //Зеленый светодиод на PIN13
int powerGSM = 9; //Пин включения GSM
int unit1 = 52; //Управляемое устройство 1
int unit2 = 53; //Управляемое устройство 2
int unit3 = 50;//Управляемое устройство 3
int unit4 = 51;//Управляемое устройство 4
int perimetr = 12;// Датчик периметра
String statusHome;
int t = 0;
unsigned long currentTime;
unsigned long loopTime;
boolean unit1status = false; //Управляемое устройство 1
boolean unit2status = false; //Управляемое устройство 2
boolean unit3status = false;//Управляемое устройство 3
boolean unit4status = false;//Управляемое устройство 4
boolean isPerimetr = false; //Контроль периметра
boolean sendSMS = false; //Для проверки что смс отсылаем только один раз
boolean isAuto = false; //Автоматическое управление температурой
int autoTemp = 0;
int delta = 2;

boolean prevBtn = LOW;

String currStr = ""; // Переменная принимает значение True, если текущая строка является сообщением
boolean isStringMessage = false;

void setup()
{
  pinMode(unit1, OUTPUT);
  pinMode(unit2, OUTPUT);
  pinMode(unit3, OUTPUT);
  pinMode(unit4, OUTPUT);
  pinMode(powerGSM, OUTPUT);
  pinMode(perimetr, INPUT);
  pinMode(greenLed, OUTPUT);
  digitalWrite(unit1, HIGH);
  digitalWrite(unit2, HIGH);
  digitalWrite(unit3, LOW);
  digitalWrite(unit4, HIGH);
  digitalWrite(powerGSM, LOW);
  digitalWrite(greenLed, LOW);

  //Включаю GSM Модуль
  //digitalWrite(powerGSM, LOW);
  //delay(5100);
  //digitalWrite(powerGSM, HIGH);
  //delay(2000);
  Serial1.begin(19200);
  
  delay(1000);
  

  // Настраиваем приём сообщений с других устройств
  // Между командами даём время на их обработку
  Serial1.print("AT+CMGF=1\r");
  delay(500);
  Serial1.println((char)26);//the ASCII code of the ctrl+z is 26
  delay(500);
  Serial1.print("AT+IFC=1, 1\r");
  delay(500);
  Serial1.print("AT+CPBS=\"SM\"\r");
  delay(500);
  Serial1.print("AT+CNMI=1,2,2,1,0\r");
  delay(500);

  //Инициализация COM-порта
  Serial.begin(19200);
  Serial.println("Serial initialized");
  //Инициализация температурного датчика
  //dht.setup(7);
  //delay(3000);

  //ParseSMS("1;20;0;1;1;1;1");
  currentTime = millis();
  loopTime = currentTime;
}

void GetDatchik() {

  // Пол
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  //float h = dht.getHumidity();
  //float t = dht.getTemperature();
  float h = 1; //debug
  float t = 2; //debug

  // check if returns are valid, if they are NaN (not a number) then something went wrong!
  if (isnan(t) || isnan(h)) {
    Serial.println("Failed to read from DHT");
  } else {
    statusHome = int(h) + String(";") + int(t) + String(";") + int(unit1status) + String(";") + int(unit2status) + String(";") + int(unit3status) + String(";") + int(unit4status) + String(";") + int(isPerimetr) + String(";") + digitalRead(perimetr) + String(";") + int(isAuto) + String(";") + int(autoTemp) + String(";STEWART");
    //Serial.println("Get datchik func.");
    //delay (1000);
    //sendTextMessage(statusHome);
    //Serial.println(statusHome); // debug
    //delay (1000);
    //Serial.println("Data collected"); // debug
    //delay (1000);

    //  Serial.print("H"); //Влажность
    //  Serial.print(h);
    //  Serial.print(";");
    //  Serial.print("T"); //Температура
    //  Serial.print(t);
    //  Serial.println(";");
    //  Serial.println(statusHome);
  }

}

void loop()

{
  // delay(5000);
  GetDatchik();
  int sostPerimetr; //Состояние периметра
  if (Serial1.available() > 0) {
  char currSymb = Serial1.read();
  //Serial.print("Message received: ");// debug
  //Serial.print(currSymb);
  //Serial.println();// debug
  //delay (1000); // debug
  //return;
        
    if ('\r' == currSymb) {
      if (isStringMessage) {
        //если текущая строка - SMS-сообщение,
        //отреагируем на него соответствующим образом
        if (!currStr.compareTo("STATUS")) // Пришёл запрос статуса
        {
          Serial.println("compare to status"); // debug
          Serial.println(currStr); // debug
          GetDatchik();
          sendTextMessage(statusHome);
          Serial.println("SMS with settings Sent"); // debug
          //delay (1000); // debug
        }

        else if (currStr.startsWith("0") || currStr.startsWith("1")) // Если пришло СМС с настройками
        {
          ParseSMS(currStr);
          Serial1.print(currStr);
          Serial.println("SMS with settings received"); // debug
          delay (1000); // debug
          Serial.print(currStr); // debug
        }
        isStringMessage = false;
      } else {
        if (currStr.startsWith("+CMT"))// Пришёл ответ от отператора или обычная СМС
        {
          //если текущая строка начинается с "+CMT",
          //то следующая строка является сообщением
          isStringMessage = true;
          Serial.println("If STR = +CMT:"); // debug
          Serial.print(currStr); // debug
        }
      }
      currStr = "";
    } else if ('\n' != currSymb) {
      currStr += String(currSymb);
      //Serial.println("IF \n"); // debug
      Serial.print(currStr); // debug
    }
  }

  //  Контроль периметра!!!
  if (isPerimetr) { //Проверка Включен ли контроль периметра
    digitalWrite(greenLed, HIGH);
    sostPerimetr = digitalRead(perimetr);
    if (sostPerimetr == LOW) { //Проверка на разомкнутый периметр
      digitalWrite(greenLed, LOW);
      delay(200);
      digitalWrite(greenLed, HIGH);
      delay(200);
      //и отсылаем СМС
      if (sendSMS == false) {
        sendTextMessage("WARNING! The perimeter is broken!"); // debug
        Serial.println("Perimeter SMS sent!"); // debug
        delay (1000); // debug
        sendSMS = true;
      }
    }

  } else {
    digitalWrite(greenLed, LOW);
  }

  //  Контроль температуры!!!
  if (isAuto == true) { //Проверка Включен автоуправление батареями
    //Замер температуры можно проводить не чаще раз в 5 минут
    currentTime = millis();
    if (currentTime >= (loopTime + 60000)) {
    //t = int(dht.getTemperature());
    t = 1; //debug
      loopTime = currentTime;
    }

    //
    //  Serial.print("t=");
    //  Serial.println(t);
    //  Serial.print("autoTemp+delta=");
    //  Serial.println(autoTemp+delta);

    if (t > autoTemp + delta) {
      if ( unit1status == true) {
        digitalWrite(unit1, LOW);
        unit1status = false;
      }
      if ( unit2status == true) {
        digitalWrite(unit2, LOW);
        unit2status = false;
      }
      if ( unit3status == true) {
        digitalWrite(unit3, LOW);
        unit3status = false;
      }
      if ( unit4status == true) {
        digitalWrite(unit4, LOW);
        unit4status = false;
      }
    } else if (t < autoTemp - delta) {
      if ( unit1status == false) {
        digitalWrite(unit1, HIGH);
        unit1status = true;
      }
      if ( unit2status == false) {
        digitalWrite(unit2, HIGH);
        unit2status = true;
      }
      if ( unit3status == false) {
        digitalWrite(unit3, HIGH);
        unit3status = true;
      }
      if ( unit4status == false) {
        digitalWrite(unit4, HIGH);
        unit4status = true;
      }
    }
  }
}

void ParseSMS(String currStr) {
  int firstSemicolon;
  //Распарсиваем SMS
  firstSemicolon = 1;//находим первую ;
  //Получаем значение Автоматического режима контроля температуры
  //if (currStr.substring(firstSemicolon+1,currStr.indexOf(';', firstSemicolon + 1 )) == "0"){
  if (currStr.substring(0, 1) == "0") {
    isAuto = false;
  }
  else {
    isAuto = true;
  }
  Serial.println(currStr.substring(0,1));
  Serial.print("isAuto=");
  Serial.println(isAuto);

  firstSemicolon = currStr.indexOf(';');
  //Получаем значение Автоматического уровня температуры
  autoTemp = stringToNumber(currStr.substring(firstSemicolon + 1, currStr.indexOf(';', firstSemicolon + 1 )));
  firstSemicolon = currStr.indexOf(';', firstSemicolon + 1 );

  Serial.println(autoTemp); // debug

  //Получаем значение Контроля периметра

  if (currStr.substring(firstSemicolon + 1, currStr.indexOf(';', firstSemicolon + 1 )) == "0") {
    isPerimetr = false;
  } else {
    isPerimetr = true;
  }

  Serial.println(isPerimetr);

  firstSemicolon = currStr.indexOf(';', firstSemicolon + 1 );


  //Получаем значение Устройства 1
  if ((currStr.substring(firstSemicolon + 1, currStr.indexOf(';', firstSemicolon + 1 )) == "0") && (isAuto == false)) {
    unit1status = false;
    digitalWrite(unit1, LOW);
   Serial.println("Устройство 1 ВЫКЛ");
  } else {
    unit1status = true;
    digitalWrite(unit1, HIGH);
   Serial.println("Устройство 1 ВКЛ");
  }
  firstSemicolon = currStr.indexOf(';', firstSemicolon + 1 );


  //Получаем значение Устройства 2
  if ((currStr.substring(firstSemicolon + 1, currStr.indexOf(';', firstSemicolon + 1 )) == "0") && (isAuto == false)) {
    unit2status = false;
    digitalWrite(unit2, LOW);
  } else {
    unit2status = true;
    digitalWrite(unit2, HIGH);
  }
  firstSemicolon = currStr.indexOf(';', firstSemicolon + 1 );


  //Получаем значение Устройства 3
  if ((currStr.substring(firstSemicolon + 1, currStr.indexOf(';', firstSemicolon + 1 )) == "0") && (isAuto == false)) {
    unit3status = false;
    digitalWrite(unit3, LOW);
  } else {
    unit3status = true;
    digitalWrite(unit3, HIGH);
  }
  firstSemicolon = currStr.indexOf(';', firstSemicolon + 1 );


  //Получаем значение Устройства 4
  if ((currStr.substring(firstSemicolon + 1, currStr.indexOf(';', firstSemicolon + 1 )) == "0") && (isAuto == false)) {
    unit4status = false;
    digitalWrite(unit4, LOW);
  } else {
    unit4status = true;
    digitalWrite(unit4, HIGH);
  }
 }

/*

* Функция отправки SMS-сообщения

*/

void sendTextMessage(String text) {
  // Устанавливает текстовый режим для SMS-сообщений
  Serial1.print("AT+CMGF=1\r");    //Because we want to send the SMS in text mode
  delay(500);
  Serial1.print("AT+CSCS=\"GSM\"\r");
  delay(500);
  Serial1.print("AT+CMGS=\"+79188354271\"\r");//send sms message
  delay(500);
  Serial1.println(text);//the content of the message
  delay(500);
  Serial1.println((char)26);//the ASCII code of the ctrl+z is 26
  delay(3000);
  Serial1.println();
  Serial.print("Message sent!");
  //Serial.println(text);
  
}

//Функция преобразовангия STRING в INT

int stringToNumber(String thisString) {
  int i, value = 0, length;
  length = thisString.length();
  for (i = 0; i < length; i++) {
    value = (10 * value) + thisString.charAt(i) - (int) '0';;
  }
  return value;
}
